//+------------------------------------------------------------------+
//|                                         Heiken Ashi T3 histo.mq4 |
//+------------------------------------------------------------------+
#property copyright "http://www.forex-tsd.com"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DodgerBlue
#property indicator_color2  Red
#property indicator_color3  DodgerBlue
#property indicator_color4  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_minimum 0
#property indicator_maximum 2

//
//
//
//
//

extern int    MaPeriod        = 10;
extern int    MaMetod         = 2;
extern int    Step            = 1;
extern bool   BetterFormula   = false;
extern bool   T3Average       = true;
extern double T3Hot           = 1.0;
extern bool   T3Original      = false;

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
//
//
//
//
//

double histUp1[];
double histDn1[];
double histUp2[];
double histDn2[];
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double trend[][2];

//
//
//
//
//


//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0, histUp1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, histDn1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, histUp2); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, histDn2); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4, Buffer1);
   SetIndexBuffer(5, Buffer2);
   SetIndexBuffer(6, Buffer3);
   SetIndexBuffer(7, Buffer4);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    pointModifier;
   int    i,r,limit;

   //
   //
   //
   //
   //
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);
         if (Digits==3 || Digits==5)
               pointModifier = 10;
         else  pointModifier = 1;               
          
   //
   //
   //
   //
   //
   
   for (i=limit,r=Bars-i-1; i >= 0; i--,r++)
   {
      if (T3Average)
        {
            double maOpen  = iT3(Open[i], MaPeriod,T3Hot,T3Original,i,0);
            double maClose = iT3(Close[i],MaPeriod,T3Hot,T3Original,i,1);
            double maLow   = iT3(Low[i],  MaPeriod,T3Hot,T3Original,i,2);
            double maHigh  = iT3(High[i], MaPeriod,T3Hot,T3Original,i,3);
        }    
      else
        {
            maOpen  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_OPEN ,i);
            maClose = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_CLOSE,i);
            maLow   = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_LOW  ,i);
            maHigh  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_HIGH ,i);
        }
   
      //
      //
      //
      //
      //
        
         if (BetterFormula) {
               if (maHigh!=maLow)
                     double haClose = (maOpen+maClose)/2 + (((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
               else  haClose        = (maOpen+maClose)/2; }
         else        haClose        = (maOpen+maHigh+maLow+maClose)/4;
                     double haOpen  = (Buffer3[i+1]+Buffer4[i+1])/2;
                     double haHigh  = MathMax(maHigh, MathMax(haOpen,haClose));
                     double haLow   = MathMin(maOpen,  MathMin(haOpen,haClose));

         if (haOpen<haClose) { Buffer1[i]=haLow;  Buffer2[i]=haHigh; } 
         else                { Buffer1[i]=haHigh; Buffer2[i]=haLow;  } 
                               Buffer3[i]=haOpen;
                               Buffer4[i]=haClose;
      
      //
      //
      //
      //
      //

      if (Step>0)
      {
         if( MathAbs(Buffer1[i] - Buffer1[i+1]) < Step*pointModifier*Point) Buffer1[i] = Buffer1[i+1];
         if( MathAbs(Buffer2[i] - Buffer2[i+1]) < Step*pointModifier*Point) Buffer2[i] = Buffer2[i+1];
         if( MathAbs(Buffer3[i] - Buffer3[i+1]) < Step*pointModifier*Point) Buffer3[i] = Buffer3[i+1];
         if( MathAbs(Buffer4[i] - Buffer4[i+1]) < Step*pointModifier*Point) Buffer4[i] = Buffer4[i+1];
      }            
      trend[r][0] = trend[r-1][0];
      trend[r][1] = trend[r-1][1];
      if (Buffer1[i] > Buffer2[i]) trend[r][0] = -1;
      if (Buffer1[i] < Buffer2[i]) trend[r][0] =  1;
      if (Buffer3[i] > Buffer4[i]) trend[r][1] = -1;
      if (Buffer3[i] < Buffer4[i]) trend[r][1] =  1;
      
      //
      //
      //
      //
      //
      
      histUp1[i] = EMPTY_VALUE;
      histDn1[i] = EMPTY_VALUE;
      histUp2[i] = EMPTY_VALUE;
      histDn2[i] = EMPTY_VALUE;
         if (trend[r][1] ==  1) histUp2[i]=1;
         if (trend[r][1] == -1) histDn2[i]=1;
         if (trend[r][0] ==  1) histUp1[i]=2;
         if (trend[r][0] == -1) histDn1[i]=2;
   }  
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      whichBar = Bars-whichBar-1;
      
      //
      //
      //
      //
      //
         
      if (trend[whichBar][0] != trend[whichBar-1][0])
      if (trend[whichBar][0] == 1)
            doAlert("up");
      else  doAlert("down");       
   }

   //
   //
   //
   //
          
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][36];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," HAMA T3 trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"HAMA T3"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

